function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _callSuper(t, o, e) { return o = _getPrototypeOf(o), _possibleConstructorReturn(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], _getPrototypeOf(t).constructor) : o.apply(t, e)); }
function _possibleConstructorReturn(t, e) { if (e && ("object" == _typeof(e) || "function" == typeof e)) return e; if (void 0 !== e) throw new TypeError("Derived constructors may only return object or undefined"); return _assertThisInitialized(t); }
function _assertThisInitialized(e) { if (void 0 === e) throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); return e; }
function _isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function _getPrototypeOf(t) { return _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf(t); }
function _inherits(t, e) { if ("function" != typeof e && null !== e) throw new TypeError("Super expression must either be null or a function"); t.prototype = Object.create(e && e.prototype, { constructor: { value: t, writable: !0, configurable: !0 } }), Object.defineProperty(t, "prototype", { writable: !1 }), e && _setPrototypeOf(t, e); }
function _setPrototypeOf(t, e) { return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, _setPrototypeOf(t, e); }
/**
 * @copyright 2020 Tridium, Inc. All Rights Reserved.
 * @author James Johnson
 */

/** @jsx spandrel.jsx */

/**
 * API Status: **Private**
 * @module nmodule/vykonPro/rc/EnhancedBoundLabel
 */
define(['baja!', 'bajaux/spandrel', 'bajaux/Widget', 'nmodule/bajaui/rc/baja/Border', 'nmodule/vykonPro/rc/EnhancedLabel', 'baja!gx:Insets,gx:Brush,gx:Color,gx:Pen,kitPx:MouseOverEffect', 'css!nmodule/kitPx/rc/kitPx', 'css!nmodule/vykonPro/rc/vykonPro'], function (baja, spandrel, Widget, Border, EnhancedLabel) {
  'use strict';

  var widgetDefaults = function widgetDefaults() {
    return {
      properties: {
        border: Border.make('1 none black'),
        rootCssClass: 'ux-EnhancedBoundLabel',
        padding: baja.$('gx:Insets', 0),
        mouseOver: baja.$('kitPx:MouseOverEffect', 'none'),
        mouseOverBgnd: baja.$('gx:Brush', 'blue'),
        mouseOverFgnd: baja.$('gx:Brush', 'white'),
        mouseOverOutline: baja.$('gx:Brush', 'red'),
        mouseOverPen: baja.$('gx:Pen', '2')
      }
    };
  };
  var counter = 0;
  /**
  * @class
  * @alias module:nmodule/vykonPro/rc/EnhancedBoundLabel
  * @extends module:nmodule/vykonPro/rc/EnhancedLabel
  */
  return /*#__PURE__*/function (_spandrel) {
    function EnhancedBoundLabel(params) {
      _classCallCheck(this, EnhancedBoundLabel);
      return _callSuper(this, EnhancedBoundLabel, [{
        params: params,
        defaults: widgetDefaults()
      }]);
    }
    _inherits(EnhancedBoundLabel, _spandrel);
    return _createClass(EnhancedBoundLabel);
  }(spandrel(function (model, _ref) {
    var properties = _ref.properties,
      rootElement = _ref.rootElement;
    var border = properties.border,
      padding = properties.padding;
    var id = 'EnhancedBoundLabel' + ++counter;
    rootElement.id = id;

    //apply the padding as a margin on the Label-col, this allows the text to be in the correct spot
    // when their isn't enough space for the padding.
    properties.margin = padding;
    return spandrel.jsx("span", {
      className: "-v-EnhancedBoundLabel-col"
    }, spandrel.jsx(EnhancedLabel, {
      tagName: "span",
      properties: properties,
      value: model
    }), spandrel.jsx("div", {
      className: "-v-EnhancedBoundLabel-border",
      $init: function $init(el) {
        return border.applyToElement(el);
      }
    }), spandrel.jsx("style", null, makeStyle(id, properties)));
  }, {
    "extends": EnhancedLabel
  }));
  function makeStyle(id, properties) {
    var mouseOver = properties.mouseOver,
      mouseOverBgnd = properties.mouseOverBgnd,
      mouseOverFgnd = properties.mouseOverFgnd,
      mouseOverOutline = properties.mouseOverOutline,
      mouseOverPen = properties.mouseOverPen;
    // different css based on mouseOver...
    if (mouseOver.getTag() === "highlight") {
      return "\n        #".concat(id, ":hover .ux-Label, #").concat(id, ":hover .-t-Label-text {\n      background-color: ").concat(mouseOverBgnd.toString(), " !important; color: ").concat(mouseOverFgnd.toString(), " !important;\n      }\n      ");
    } else if (mouseOver.getTag() === "outline") {
      var penStyle = mouseOverPen.toString();
      var borderStyle = 'solid !important;';
      if (penStyle.indexOf('dash(2,2)') > -1) {
        // dotted pen
        borderStyle = 'dotted !important;';
      } else if (penStyle.indexOf('dash(8,2)') > -1) {
        // dashed pen
        borderStyle = 'dashed !important;';
      }
      ;
      return "\n        #".concat(id, " .-v-EnhancedBoundLabel-border:hover { \n      border-color: ").concat(mouseOverOutline.toString(), " !important; \n      border-style: ") + borderStyle + "border-width: ".concat(mouseOverPen.getWidth(), "px !important;\n      }\n      ");
    }
  }
});
