function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _callSuper(t, o, e) { return o = _getPrototypeOf(o), _possibleConstructorReturn(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], _getPrototypeOf(t).constructor) : o.apply(t, e)); }
function _possibleConstructorReturn(t, e) { if (e && ("object" == _typeof(e) || "function" == typeof e)) return e; if (void 0 !== e) throw new TypeError("Derived constructors may only return object or undefined"); return _assertThisInitialized(t); }
function _assertThisInitialized(e) { if (void 0 === e) throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); return e; }
function _isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function _getPrototypeOf(t) { return _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf(t); }
function _inherits(t, e) { if ("function" != typeof e && null !== e) throw new TypeError("Super expression must either be null or a function"); t.prototype = Object.create(e && e.prototype, { constructor: { value: t, writable: !0, configurable: !0 } }), Object.defineProperty(t, "prototype", { writable: !1 }), e && _setPrototypeOf(t, e); }
function _setPrototypeOf(t, e) { return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, _setPrototypeOf(t, e); }
/**
 * Copyright 2021 Tridium, Inc. All Rights Reserved.
 */

/* jshint browser: true */ /* eslint-env browser */

/* global niagara */

/**
 * API Status: **Private**
 * @module nmodule/vykonPro/rc/binding/EnhancedHyperlinkBinding
 */
define(['baja!', 'nmodule/bajaui/rc/baja/binding/Binding', 'nmodule/bajaui/rc/binding/impl/widgetEvents', 'Promise', 'log!uxMedia', 'css!nmodule/vykonPro/rc/vykonPro'], function (baja, Binding, widgetEvents, Promise, log) {
  'use strict';

  var logSevere = log.severe.bind(log);

  /**
   * BajaScript implementation of a `vykonPro:EnhancedHyperlinkBinding`.
   * @class
   * @alias module:nmodule/vykonPro/rc/binding/EnhancedHyperlinkBinding
   * @extends module:nmodule/bajaui/rc/baja/binding/Binding
   */
  return /*#__PURE__*/function (_Binding) {
    function EnhancedHyperlinkBinding() {
      _classCallCheck(this, EnhancedHyperlinkBinding);
      return _callSuper(this, EnhancedHyperlinkBinding, arguments);
    }
    _inherits(EnhancedHyperlinkBinding, _Binding);
    return _createClass(EnhancedHyperlinkBinding, [{
      key: "addListeners",
      value:
      /**
       * Add event listeners for the widget:
       *
       * - on click, popup
       * - add CSS to indicate cursor
       *
       * @param {module:bajaux/Widget} widget
       */
      function addListeners(widget) {
        var _this = this;
        this.addWidgetEvents(widget, {
          click: function click(e) {
            var ord = _this.get('ord');
            if (ord.isNull()) {
              return;
            }
            return _this.$formatHyperlink().then(function (hyperlink) {
              var url = hyperlink.toUri();
              var target = _this.get('browserTarget');
              if (target === "_self" || target === "_parent") {
                e.preventDefault();
                return Promise["try"](function () {
                  return niagara.env.hyperlink(hyperlink);
                })["catch"](logSevere);
              } else {
                window.open(url, target);
              }
            });
          },
          initialized: function initialized() {
            var ord = _this.get('ord');
            widget.jq().addClass('ux-EnhancedHyperlinkBinding').toggleClass('hyperlink-target', !ord.isNull());
          },
          destroyed: function destroyed() {
            widget.jq().removeClass('ux-EnhancedPopupBinding hyperlink-target');
          }
        });
      }

      /*
      * resolve hyperlinkFormat against ord to determine hyperlink URL
      */
    }, {
      key: "$formatHyperlink",
      value: function $formatHyperlink() {
        return this.get('hyperlinkFormat').format({
          object: this.getOrdTarget().getObject()
        })
        //.then(baja.Ord.make);
        .then(function (value) {
          return baja.Ord.make({
            base: "station:",
            child: value
          });
        });
      }
    }]);
  }(Binding);
});
