function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _callSuper(t, o, e) { return o = _getPrototypeOf(o), _possibleConstructorReturn(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], _getPrototypeOf(t).constructor) : o.apply(t, e)); }
function _possibleConstructorReturn(t, e) { if (e && ("object" == _typeof(e) || "function" == typeof e)) return e; if (void 0 !== e) throw new TypeError("Derived constructors may only return object or undefined"); return _assertThisInitialized(t); }
function _assertThisInitialized(e) { if (void 0 === e) throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); return e; }
function _isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function _getPrototypeOf(t) { return _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf(t); }
function _inherits(t, e) { if ("function" != typeof e && null !== e) throw new TypeError("Super expression must either be null or a function"); t.prototype = Object.create(e && e.prototype, { constructor: { value: t, writable: !0, configurable: !0 } }), Object.defineProperty(t, "prototype", { writable: !1 }), e && _setPrototypeOf(t, e); }
function _setPrototypeOf(t, e) { return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, _setPrototypeOf(t, e); }
/**
 * Copyright 2021 Tridium, Inc. All Rights Reserved.
 */

/* jshint browser: true */ /* eslint-env browser */

/**
 * API Status: **Private**
 * @module nmodule/vykonPro/rc/binding/ToolTipBinding
 */
define(['baja!', 'nmodule/bajaui/rc/baja/binding/Binding', 'nmodule/bajaui/rc/binding/impl/widgetEvents', 'nmodule/webEditors/rc/fe/baja/util/DepthSubscriber', 'Promise', 'log!uxMedia', 'css!nmodule/vykonPro/rc/vykonPro'], function (baja, Binding, widgetEvents, DepthSubscriber, Promise, log) {
  'use strict';

  //const logSevere = log.severe.bind(log);

  /**
   * BajaScript implementation of a `vykonPro:ToolTipBinding`.
   * @class
   * @alias module:nmodule/vykonPro/rc/binding/ToolTipBinding
   * @extends module:nmodule/bajaui/rc/baja/binding/Binding
   */
  return /*#__PURE__*/function (_Binding) {
    function ToolTipBinding() {
      _classCallCheck(this, ToolTipBinding);
      return _callSuper(this, ToolTipBinding, arguments);
    }
    _inherits(ToolTipBinding, _Binding);
    return _createClass(ToolTipBinding, [{
      key: "addListeners",
      value:
      /**
           * Add event listeners for the widget:
           *
           * - on click, popup
           * - add CSS to indicate cursor
           *
           * @param {module:bajaux/Widget} widget
           */
      function addListeners(widget) {
        var _this = this;
        this.addWidgetEvents(widget, {
          mouseenter: function mouseenter(e) {
            var ord = _this.get('ord');
            if (ord.isNull()) {
              return;
            }

            // TODO remove + 1 when NCCB-25711 is resolved
            var sub = new DepthSubscriber(_this.get('leaseDepth').valueOf() + 1);
            return ord.get({
              subscriber: sub
            }).then(function (comp) {
              return _this.$formatTip().then(function (tip) {
                widget.jq().attr("title", tip);
                sub.unsubscribeAll();
              });
            });
          },
          initialized: function initialized() {
            widget.jq().addClass('ux-ToolTipBinding');
          },
          destroyed: function destroyed() {
            widget.jq().removeClass('ux-ToolTipBinding');
          }
        });
      }

      /*
      * resolve toolTip BFormat against ord to determine text
      */
    }, {
      key: "$formatTip",
      value: function $formatTip() {
        return this.get('toolTip').format({
          object: this.getOrdTarget().getObject()
        });
      }
    }]);
  }(Binding);
});
