function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(a, n) { if (!(a instanceof n)) throw new TypeError("Cannot call a class as a function"); }
function _defineProperties(e, r) { for (var t = 0; t < r.length; t++) { var o = r[t]; o.enumerable = o.enumerable || !1, o.configurable = !0, "value" in o && (o.writable = !0), Object.defineProperty(e, _toPropertyKey(o.key), o); } }
function _createClass(e, r, t) { return r && _defineProperties(e.prototype, r), t && _defineProperties(e, t), Object.defineProperty(e, "prototype", { writable: !1 }), e; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _callSuper(t, o, e) { return o = _getPrototypeOf(o), _possibleConstructorReturn(t, _isNativeReflectConstruct() ? Reflect.construct(o, e || [], _getPrototypeOf(t).constructor) : o.apply(t, e)); }
function _possibleConstructorReturn(t, e) { if (e && ("object" == _typeof(e) || "function" == typeof e)) return e; if (void 0 !== e) throw new TypeError("Derived constructors may only return object or undefined"); return _assertThisInitialized(t); }
function _assertThisInitialized(e) { if (void 0 === e) throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); return e; }
function _isNativeReflectConstruct() { try { var t = !Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); } catch (t) {} return (_isNativeReflectConstruct = function _isNativeReflectConstruct() { return !!t; })(); }
function _getPrototypeOf(t) { return _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function (t) { return t.__proto__ || Object.getPrototypeOf(t); }, _getPrototypeOf(t); }
function _inherits(t, e) { if ("function" != typeof e && null !== e) throw new TypeError("Super expression must either be null or a function"); t.prototype = Object.create(e && e.prototype, { constructor: { value: t, writable: !0, configurable: !0 } }), Object.defineProperty(t, "prototype", { writable: !1 }), e && _setPrototypeOf(t, e); }
function _setPrototypeOf(t, e) { return _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function (t, e) { return t.__proto__ = e, t; }, _setPrototypeOf(t, e); }
/**
 * @copyright 2020 Tridium, Inc. All Rights Reserved.
 * @author James Johnson
 */

/**
 * API Status: **Private**
 * @module nmodule/vykonPro/rc/binding/ViewNameBinding
 */
define(['baja!', 'Promise', 'nmodule/bajaui/rc/baja/binding/Binding', 'nmodule/webEditors/rc/wb/profile/profileUtils', 'css!nmodule/bajaui/rc/bajaui'], function (baja, Promise, Binding, profileUtils) {
  'use strict';

  /**
   * @class
   * @alias module:nmodule/vykonPro/rc/binding/ViewNameBinding
   * @extends module:nmodule/bajaui/rc/baja/binding/Binding
   */
  return /*#__PURE__*/function (_Binding) {
    function ViewNameBinding() {
      _classCallCheck(this, ViewNameBinding);
      return _callSuper(this, ViewNameBinding, arguments);
    }
    _inherits(ViewNameBinding, _Binding);
    return _createClass(ViewNameBinding, [{
      key: "provide",
      value:
      /**
       * Converts the bound `BObject` to a type that is compatible with the target
       * property on the bound `Widget`.
       *
       * @param {string} name
       * @returns {Promise.<*|null>}
       */
      function provide(name) {
        if (!this.isBound() || !name.equals("text")) {
          return null;
        }
        var tformat = this.get("textFormat").toString();
        var ordTarget = this.getOrdTarget();
        return profileUtils.resolveCurrentViewId().then(function (item) {
          if (item) {
            return profileUtils.getOrdWithoutViewQuery().relativizeToSession().get().then(function (rootComp) {
              var viewDn = rootComp.getDisplayName(rootComp.getSlot(item));
              tformat = tformat.replace("viewName", viewDn);
              var fmt = baja.Format.make(tformat);
              return resolveText(ordTarget, fmt).then(function (textValue) {
                return textValue;
              });
            });
          }
        });
      }
    }]);
  }(Binding);

  /**
   * @returns {Promise}
   */
  function resolveText(ordTarget, fmt) {
    return fmt.format({
      object: ordTarget.getObject()
    });
  }
});
